/*
 * Simple hash implementation using single table, not resizeable, from
 * the top of my head.
 */

# include <fcntl.h>


typedef struct hashdag
{
  unsigned key;
  void *data;
  struct hash *next;
}
hash_t;

typedef struct hashstat
{
  unsigned find1;
  unsigned find2;
  unsigned count;
}
hashstat_t;

extern int hash_create (unsigned size);
extern void hash_destroy (void);

extern hash_t *hash_find (unsigned key);
extern hash_t *hash_enter (unsigned key);
extern int hash_delete (unsigned key);
extern hash_t *hash_walk (int start);
extern void hash_clearstat (void);

extern hashstat_t hashstat;

/*
 * Progress reporting
 */
void progress_init (int level, off_t total, char *name, char *dir);
void progress_finish (void);

extern off_t progress_bytes;	/* the current size */

/*
 * Internet checksum computation
 */
unsigned short in_chksum (unsigned short *buf, int len);

/*
 * Converts a string of form YYYYMMMDD-HHMMSS into a UNIX time_t.
 */
extern time_t trtime (char *s);

/*
 * Reporting support
 */
extern void panic (char *fmt, ...)
  __attribute__ ((noreturn, format (printf, 1, 2)));
