.TH tstat 1
.SH NAME
tstat - TCP STatistic and Analisys Tool
.SH SYNOPSIS
.B tstat  [-Nfile] [-d] [-htuvw] [-sdir] <file>
.SH DESCRIPTION
tstat
takes a tcpdump file specified on the command line (or from standard input)
and produces a number of different histograms collecting statistics both
ath the IP and TCP level.
.SH "Options"
.br
.TP 5
.B \-Nfile
specify the file name which contains the
description of the internal networks.
This file must contain the subnets that will be
considered as 'internal' during the analyisis
Each subnet must be specified using IP address
on the first line and netmask on the second one:
.br
                130.192.0.0
.br
                255.255.0.0
.br
                193.204.134.0
.br
                255.255.255.0
.TP 5
.B \-d
whistle while you work (enable debug, use -d -d for more output)
.TP 5
.B \-h
printa brief help and exit.
.TP 5
.B \-t
print ticks during file elaboration.
.TP 5
.B \-u
trace also UDP packets. Very primitive.
.TP 5
.B \-v
print version and exit.
.TP 5
.B \-w
print warnings when something strange is observed on the trace.
.TP 5
.B \-sdir
puts the trace analysis into directory tree dir (otherwise it will be
<file>.out)
.SH DESCRIPTION
The lack of automatic tools able to produce statistical data from
collected network traces was a major motivation to develop Tstat, a
new tool which, starting from standard software libraries, is able to
offer network managers and researchers important information about
classic and novel performance indices and statistical data about
Internet traffic.
  
Started as evolution of  TCPtrace,
Tstat is able to analyze traces in real time, using common PC
hardware, or  start from previously recorded traces in various dump
formats, such as the one supported by the libpcap library. The software assumes to receive as input a trace collected on an edge node, such that both data
segments and ACK segments can be analyzed. Besides the more common IP
statistics, derived from the analysis of the IP header, Tstat is
also able to rebuild each TCP connection status looking at the TCP header
in the forward and backward packet flows. If connection opening and
closing is observed, the flow is marked as a complete flow, and
then analyzed. To free memory related to status used by TCP flows that are
inactive, a timer of 30 minutes is used as garbage collector.  TCP
segments that belong to flows whose opening is not recorded (because
either were started before, or early declared closed by the garbage procedure) are discarded and marked as ``trash''.
The TCP flow analysis allows the derivation of novel statistics, such as,
for example, the congestion window size, out-of- sequence segments,
duplicated segments, etc.
    
Statistic are collected distinguishing between clients and
servers, i.e., host that actively open a connection and host
that replay to the connection request, but also identifying
internal and external hosts, i.e., hosts located inside
or outside the edge node used as measurement point. 
Thus incoming and
outgoing packets/flows are identified.
    
Instead of dumping single measured data, for each measured quantity Tstat builds a histogram, collecting the distribution of that given quantity.
Every 15 minutes, it produces a dump of all the histograms it collected. A
set of companion tools are available to produce both time plot, or
aggregated plot over different time spans. Moreover a Web interface is
available, which allows the user to travel among all the collected data, select the desired quantity, and directly produce graphs, as well as
retrieve the raw data that can then later be used for further analysis.
    
A total of 79 different histogram types are available, comprising  both IP
and TCP statistics. They range from classic measures directly available
from packet headers (e.g., percentage of TCP or UDP packets, packet
length distribution, TCP port distribution, ...), to advanced
measures, related to TCP (e.g., average congestion window, RTT estimates,
out-of- sequence data, duplicated data, ...). A complete log also keeps track of all the TCP flow analyzed, and is useful for post- processing
purpose.
.SH AUTHOR
Marco Mellia, Andrea Carpani, Renato Lo Cigno
mellia@mail.tlc.polito.it, locigno@mail.tlc.polito.it

.SH CREDITS
Thanks to Shawn Ostermann (ostermann@cs.ohiou.edu)
for writing the TCPtrace tool, that is 80% of the core af tstat.
See http://www.tcptrace.org
.SH FILES
Dump File Names
.br
Trailing (unrecognized) arguments are taken to be one or more filenames.
The files can be compressed, see compress.h for configuration.
If the dump file name is 'stdin', then we read from standard input
rather than from a file.
.SH OUTPUT
tstat produces a number of histograms every 15 minutes, that are collected
into a directory with an increasing number.
When working in a on-line fashion (i.e., 'stdin' is passed  as input file),
about every traced hour will produce a new subfolder.
.br
please, refer to the tstat web page for more detail:
http://tstat.tlc.polito.it


.SH SEE ALSO
.TP 8
.B tcptrace, tcpdump, libpcap.

